View Issue Details

IDProjectCategoryView StatusLast Update
0000230Adventure PHP FrameworkNeues Feature // New Featurepublic2015-10-12 12:19
ReporterChristianAchatzAssigned ToChristianAchatz 
PrioritynormalSeverityfeatureReproducibilityN/A
Status closedResolutionfixed 
Product Version2.1 
Target Version3.0Fixed in Version3.0 
Summary0000230: Introduction of ID access to the APF DOM tree
DescriptionATM, accessing the DOM tree requires exact knowledge of where the desired target is located. One may use Document::getChildNode(), HtmlFormTag::getFormElementById(), etc. but is not able to access a DOM element regardless where it is located (e.g. template).

Within this change there should be an option to access a DOM node declared with attribute "apf-dom-id" using a dedicated method (e.g. getDomNodeById()) similar to Java Script.
TagsNo tags attached.
Codereferenz: ([Datei]:[Zeile])
Namespacecore

Activities

dingsda

2014-08-11 09:39

developer   ~0000482

danke, dass du aus unserer unterhaltung im dev-chat den feature-request erstellt hast. mangels zeit hatte ich es noch nicht selbst gemacht.

meine gedanken dazu:

ich denke es ist unnötig das attribut apf-dom-id zu nennen. es schadet doch nichts einfach id zu nutzen welches in html-tags sowieso schon genutzt werden kann.

wieso eigentlich nur die id über mehrere ebenen zugreifbar machen? in javascript ist es ja auch über andere attribute möglich oder über den tag-namen oder oder...
würde Document::getChildNode() auch tiefere strukturen des baums durchsuchen würde das problem auch gelöst werden können

ChristianAchatz

2014-08-11 15:32

administrator   ~0000483

Hallo dingsda,

gerne! :)

"apf-dom-id" hatte ich gewählt um bewusst von der HTML-Id zu unterscheiden. Diese wird üblicherweise im HTML und CSS verwendet (oft auch in Java Script) und daher von ihrer Semantik eine etwas andere. Nutzen wir ein dediziertes Attribut, dann kann ich dieses vom Rendern ausnehmen und muss nicht - oft unnütz - mehr HTML in den Quellcode rendern, weil es das Framework verlangt.

Tag-Namen für den Zugriff zu nutzen ist nicht eindeutig, da es im Baum immer mehrere gleiche Tags gibt. Aus Performance-Gründen ist es nicht gut beim Zugriff zu rekursiv zu suchen, sondern einen dedizierten Mechanismus im parser dafür vorzusehen. Daher auch die Idee mit dem "apf-dom-id"-Attribut.

Wenn du mehr Ideen für die Zugriffsarten hast, immer gerne. Ich denke Id ist schon ausreichend - zumindest gerade für die Formular-Themen, die ich mir gerade ansehe.

ChristianAchatz

2014-08-13 22:34

administrator   ~0000485

Implementation done, docs to be done (write chapter "parser secrets").

ChristianAchatz

2014-09-06 14:36

administrator   ~0000494

Documentation done.

Issue History

Date Modified Username Field Change
2014-08-08 15:40 ChristianAchatz New Issue
2014-08-08 15:40 ChristianAchatz Status new => assigned
2014-08-08 15:40 ChristianAchatz Assigned To => ChristianAchatz
2014-08-11 09:39 dingsda Note Added: 0000482
2014-08-11 15:32 ChristianAchatz Note Added: 0000483
2014-08-13 22:34 ChristianAchatz Note Added: 0000485
2014-09-06 14:36 ChristianAchatz Note Added: 0000494
2014-09-06 14:36 ChristianAchatz Status assigned => resolved
2014-09-06 14:36 ChristianAchatz Fixed in Version => 3.0
2014-09-06 14:36 ChristianAchatz Resolution open => fixed
2015-10-12 12:19 ChristianAchatz Status resolved => closed